// Netify Agent
// Copyright (C) 2015-2024 eGloo Incorporated
// <http://www.egloo.ca>
//
// This program is free software: you can redistribute it
// and/or modify it under the terms of the GNU General
// Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your
// option) any later version.
//
// This program is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the
// implied warranty of MERCHANTABILITY or FITNESS FOR A
// PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program.  If not, see
// <http://www.gnu.org/licenses/>.

#pragma once

#include <string>

#include "nd-addr.hpp"
#include "nd-util.hpp"

using namespace std;

#define ND_DHC_FILE_NAME "/dns-cache.csv"

class ndDNSHintCache : public ndLRUCache<string, string>
{
public:
    ndDNSHintCache(size_t cache_size);

    void Insert(const ndAddr &addr, const string &hostname);
    void Insert(const string &digest, const string &hostname);

    bool Lookup(const ndAddr &addr, string &hostname);
    inline bool Lookup(const string &digest, string &hostname) {
        return CacheLookup(digest, hostname);
    }

    void Load(void);
    void Save(void) const;
};
